VillainTools = {}

local function removeDuplicates(list)
    local result = {}
    local seen = {}
    for _,item in ipairs(list) do
        if not seen[item] then
            seen[item] = true
            table.insert(result, item)
        end
    end
    return result
end

function VillainTools.doMenu(player, context, worldobjects, test)
    if not (isClient() and (isAdmin() or getAccessLevel() == "moderator")) then return true; end
    if test and ISWorldObjectContextMenu.Test then return true end

    local square = nil;
    for i,v in ipairs(worldobjects) do
        square = v:getSquare();
        break;
    end

    for i=1,square:getObjects():size() do
        table.insert(worldobjects, square:getObjects():get(i-1))
    end
    worldobjects = removeDuplicates(worldobjects)

    local playerObj = getSpecificPlayer(player)
    local debugOption = context:addOption("Villain Tools", worldobjects, nil);
    local subMenu = ISContextMenu:getNew(context);
    context:addSubMenu(debugOption, subMenu);
    subMenu:addOption("Horde Manager", square, VillainTools.onHordeManager, playerObj);
end

VillainTools.onHordeManager = function(square, player)
    local ui = ISSpawnHordeUI:new(0, 0, player, square);
    ui:initialise();
    ui:addToUIManager();
end

Events.OnFillWorldObjectContextMenu.Add(VillainTools.doMenu);