HoraceServerCommands = HoraceServerCommands or {}

function HoraceServerCommands.OnServerCommand(module, command, args)
	if module == 'horace' and HoraceServerCommands[command] then
		local argStr = ''
		args = args or {}
		for k,v in pairs(args) do
			argStr = argStr..' '..k..'='..tostring(v)
		end
		--print('received '..module..' '..command..' '..tostring(player)..argStr)
		HoraceServerCommands[command](args)
	end
end

function HoraceServerCommands.UnmimicCorpse(args)
	local corpseId = args.corpseId
	local x = args.x
	local y = args.y
	local z = args.z
    local slot = args.slot
    local item = args.item
    local itemId = args.itemId
	local square = getSquare(x, y, z)
	local corpses = square:getDeadBodys()
	for i=0, corpses:size() - 1 do
		local corpse = corpses:get(i)
		if corpse:getObjectID() == corpseId then
            local container = corpse:getContainer()
            if container then
                container:removeAllItems()
                local wornItems = corpse:getWornItems()
                wornItems:clear()
                
                local inventoryItem = InventoryItemFactory.CreateItem(item)
                inventoryItem:setID(itemId)
                container:AddItem(inventoryItem)
                wornItems:setItem(slot, inventoryItem)

                container:requestServerItemsForContainer()
            end
		end
	end
end

function HoraceServerCommands.ZombieMessage(args)
	local zombieId = args.zombieId
	local x = args.x
	local y = args.y
	local z = args.z
	local message = args.message

	local zombie = HoraceServerCommands.GetZombieById(zombieId)
	if zombie then
		zombie:addLineChatElement(message)
	end
end

function HoraceServerCommands.Mimic(args)
	local zombieId = args.zombieId
	local x = args.x
	local y = args.y
	local z = args.z
	local target = args.target

	local zombie = HoraceServerCommands.GetZombieById(zombieId)
	if zombie then
		HoraceAbilities.StartMimicking(zombie, getPlayerFromUsername(target), HoraceTypes.GetZombieHorace(zombie), HoraceTypes.GetSaneHoraceData(zombie))
	end
end

function HoraceServerCommands.GetZombieById(zombieId)
	local cell = getCell()
	local zombies = cell:getZombieList()
	for i=0, zombies:size()-1 do
		local zombie = zombies:get(i)
		if zombie:getOnlineID() == zombieId then
			return zombie
		end
	end
	return nil
end

Events.OnServerCommand.Add(HoraceServerCommands.OnServerCommand)