Koshmar = {}
Koshmar.processing = false

-- TODO We want this to use BannedOutfits and override the handler there. Might need to store slot locations in banned outfits as well for the lookup

function Koshmar.IsKoshmarItem(item)
    local itemName = item and item:getVisual():getItemType() or nil
    return itemName == "Base.Light_Woman" or itemName == "Base.SH_Closer" or itemName == "Base.Bloodsucker" or itemName == "Base.Crawler" or itemName == "Base.Mutant"  or itemName == "Base.Spider"  or itemName == "Base.Pangolin" or itemName == "Base.Spiky" or itemName == "Base.SH_Nurse" or itemName == "Base.SH_Nurse_2" or itemName == "Base.Slurpy" or itemName == "Base.Scout" or itemName == "Base.Strongboy"
end

function Koshmar.IsWearingKoshmar(player)
    local wornJacket = player:getWornItems():getItem("Jacket")
    local wornFullSuit = player:getWornItems():getItem("FullSuit")
    return (wornJacket and Koshmar.IsKoshmarItem(wornJacket)) or (wornFullSuit and Koshmar.IsKoshmarItem(wornFullSuit))
end

function Koshmar.onClothingUpdated(player)
    if Koshmar.processing then
        return
    end
    Koshmar.processing = true
    local modData = player:getModData()
    if Koshmar.IsWearingKoshmar(player) and player:getAccessLevel() == "None" and not player:isGodMod() then
        player:splatBloodFloorBig()
        for i=0,5 do
            player:addBlood(BloodBodyPartType.Hand_L, true, true, true);
            player:addBlood(BloodBodyPartType.Hand_R, true, true, true);
            player:addBlood(BloodBodyPartType.ForeArm_L, true, true, true);
            player:addBlood(BloodBodyPartType.ForeArm_R, true, true, true);
            player:addBlood(BloodBodyPartType.UpperArm_L, true, true, true);
            player:addBlood(BloodBodyPartType.UpperArm_R, true, true, true);
            player:addBlood(BloodBodyPartType.Torso_Upper, true, true, true);
            player:addBlood(BloodBodyPartType.Torso_Lower, true, true, true);
            player:addBlood(BloodBodyPartType.Head, true, true, true);
            player:addBlood(BloodBodyPartType.Neck, true, true, true);
            player:addBlood(BloodBodyPartType.Groin, true, true, true);
            player:addBlood(BloodBodyPartType.UpperLeg_L, true, true, true);
            player:addBlood(BloodBodyPartType.UpperLeg_R, true, true, true);
            player:addBlood(BloodBodyPartType.LowerLeg_L, true, true, true);
            player:addBlood(BloodBodyPartType.LowerLeg_R, true, true, true);
            player:addBlood(BloodBodyPartType.Foot_L, true, true, true);
            player:addBlood(BloodBodyPartType.Foot_R, true, true, true);
            player:addBlood(BloodBodyPartType.Back, true, true, true);
        end
        for i = 0, 16 do
            player:getBodyDamage():SetBleeding(i, true)
            player:getBodyDamage():SetWounded(i, true)
        end
        player:getBodyDamage():setInfected(true)
        player:getStats():setPanic(100)
        player:getStats():setPain(100)
        if not modData.FuckedAroundAndFoundKoshmar then
            player:playSound("zombieeating")
            player:playSound("splat1")
            player:playSound("stab2")
            player:playSoundLocal("stab2")
        end
        player:playSoundLocal("zombieeating")
        player:playSoundLocal("splat1")
        player:playSoundLocal("insane4")
        modData.FuckedAroundAndFoundKoshmar = true
    elseif modData.FuckedAroundAndFoundKoshmar and player:getAccessLevel() == "None" and not player:isGodMod() then
        player:playSoundLocal("insanityambient")
        player:splatBloodFloorBig()
        player:setHealth(0)
    else
        modData.FuckedAroundAndFoundKoshmar = false
    end
    Koshmar.processing = false
end

function Koshmar.OnFillInventoryObjectContextMenu(playerIndex, context, items)
    local player = getSpecificPlayer(playerIndex)
    if Koshmar.IsWearingKoshmar(player) and player:getAccessLevel() == "None" and not player:isGodMod() then
        context:removeOptionByName(getText("ContextMenu_Unequip"))
        context:removeOptionByName(getText("ContextMenu_Wear"))
        context:removeOptionByName(getText("ContextMenu_Drop"))
        context:removeOptionByName(getText("ContextMenu_PlaceItemOnGround"))
    end
end

Events.OnClothingUpdated.Add(Koshmar.onClothingUpdated);
Events.OnFillInventoryObjectContextMenu.Add(Koshmar.OnFillInventoryObjectContextMenu);