HoraceClientCommands = HoraceClientCommands or {}

function HoraceClientCommands.OnClientCommand(module, command, player, args)
	if module == 'horace' and HoraceClientCommands[command] then
		local argStr = ''
		args = args or {}
		for k,v in pairs(args) do
			argStr = argStr..' '..k..'='..tostring(v)
		end
		--print('received '..module..' '..command..' '..tostring(player)..argStr)
		HoraceClientCommands[command](player, args)
	end
end

function HoraceClientCommands.HoraceCrash(player, args)
	local vehicle = getVehicleById(args.vehicle)
    local hitForce = args.hitForce
    local horace = args.horace
    local horaceDied = args.horaceDied
    local fromBehind = args.fromBehind
	if vehicle then
		HoraceVehicleDamage.DoHoraceCarDamage(player, vehicle, hitForce, horace, horaceDied, fromBehind);
	else
		print('no such vehicle id='..tostring(args.vehicle))
	end
end

function HoraceClientCommands.ScreechInhale(player, args)
	local zombieId = args.zombieId
	local message = args.message
	local sound = args.sound
	local x = args.x
	local y = args.y
	local z = args.z

	playServerSound(sound, getSquare(x, y, z))

	if message then
		sendServerCommand("horace", "ZombieMessage", {zombieId = zombieId, x = x, y = y, z = z, message = message})
	end
end

function HoraceClientCommands.Screech(player, args)
	local zombieId = args.zombieId
	local message = args.message
	local sound = args.sound
	local x = args.x
	local y = args.y
	local z = args.z

	playServerSound(sound, getSquare(x, y, z))

	if message then
		sendServerCommand("horace", "ZombieMessage", {zombieId = zombieId, x = x, y = y, z = z, message = message})
	end
end

function HoraceClientCommands.Slurp(player, args)
	local zombieId = args.zombieId
	local message = args.message
	local sound = args.sound
	local x = args.x
	local y = args.y
	local z = args.z

	playServerSound(sound, getSquare(x, y, z))

	if message then
		sendServerCommand("horace", "ZombieMessage", {zombieId = zombieId, x = x, y = y, z = z, message = message})
	end
end

function HoraceClientCommands.Mimic(player, args)
	local zombieId = args.zombieId
	local target = args.target
	local x = args.x
	local y = args.y
	local z = args.z

	if message then
		sendServerCommand("horace", "Mimic", {zombieId = zombieId, x = x, y = y, z = z, target = target})
	end
end

function HoraceClientCommands.UnmimicCorpse(player, args)
	local corpseId = args.corpseId
	local x = args.x
	local y = args.y
	local z = args.z
	local slot = args.slot
	local item = args.item
	local square = getSquare(x, y, z)
	local corpses = square:getDeadBodys()
	for i=0, corpses:size() - 1 do
		local corpse = corpses:get(i)
		if corpse:getObjectID() == corpseId then
			local container = corpse:getContainer()
			if container then
				container:removeAllItems()
				local wornItems = corpse:getWornItems()
				wornItems:clear()
				
				local inventoryItem = InventoryItemFactory.CreateItem(item)
				container:AddItem(inventoryItem)
				wornItems:setItem(slot, inventoryItem)

				sendServerCommand("horace", "UnmimicCorpse", {x = x, y = y, z = z, corpseId = corpseId, slot = slot, item = item, itemId = inventoryItem:getID()})
			end
		end
	end
end

Events.OnClientCommand.Add(HoraceClientCommands.OnClientCommand)