HoraceEvents = HoraceEvents or {}

function HoraceEvents.OnZombieUpdate(Zombie) 
    local horace = HoraceTypes.GetZombieHorace(Zombie)
    if horace then
        local horaceData = HoraceTypes.GetSaneHoraceData(Zombie)
        HoraceSounds.OnHoraceUpdate(Zombie, horace, horaceData)
        HoraceAbilities.OnHoraceUpdate(Zombie, horace, horaceData)
        HoraceVehicleDamage.DetectHits(Zombie, horace, horaceData)
    end
end

function HoraceEvents.OnZombieHit(Zombie, Player, Part, Weapon)
    local horace = HoraceTypes.GetZombieHorace(Zombie)
    if horace then
        local horaceData = HoraceTypes.GetSaneHoraceData(Zombie)
        HoraceSounds.OnHoraceHit(Zombie, Player, Part, Weapon, horace, horaceData)
        HoraceAbilities.OnHoraceHit(Zombie, Player, Part, Weapon, horace, horaceData)
    end
end

function HoraceEvents.OnZombieDead(Zombie)
    local horace = HoraceTypes.GetZombieHorace(Zombie)
    if horace then
        local horaceData = HoraceTypes.GetSaneHoraceData(Zombie)
        HoraceVehicleDamage.OnHoraceDead(Zombie, horace, horaceData)
        HoraceSounds.OnHoraceDead(Zombie, horace, horaceData)
        HoraceAbilities.OnHoraceDead(Zombie, horace, horaceData)
    end
end

Events.OnZombieUpdate.Add(HoraceEvents.OnZombieUpdate)
Events.OnHitZombie.Add(HoraceEvents.OnZombieHit)
Events.OnZombieDead.Add(HoraceEvents.OnZombieDead)