HoraceSounds = HoraceSounds or {}

function HoraceSounds.OnHoraceUpdate(Zombie, Horace, HoraceData)
    local idleSoundChance = Horace.IdleSoundChance or 0.001
    if ZombRandFloat(0, 1) <= idleSoundChance then
        local sound = HoraceTypes.PickSound(Horace.IdleSound)
        if sound ~= nil then
            Zombie:playSoundLocal(sound)
        end
    end

    if Horace.TargetSound then
        local targetSound = HoraceTypes.PickSound(Horace.TargetSound)
        if targetSound ~= nil then
            local target = Zombie:getTarget()
            if target ~= nil and HoraceData.LastTarget ~= target:getID() then
                Zombie:playSoundLocal(targetSound)
                HoraceData.LastTarget = target:getID()
            end
        end
    end

    if Horace.ChargeSound then
        local chargeSound = HoraceTypes.PickSound(Horace.ChargeSound)
        if chargeSound ~= nil then
            local target = Zombie:getTarget()
            if target ~= nil and HoraceData.LastTargetCharge ~= target:getID() and (Zombie:isCurrentState(WalkTowardState.instance()) or Zombie:isCurrentState(LungeState.instance())) then
                Zombie:playSoundLocal(chargeSound)
                HoraceData.LastTargetCharge = target:getID()
            end
        end
    end
end

function HoraceSounds.OnHoraceHit(Zombie, Player, Part, Weapon, Horace)
    local sound = HoraceTypes.PickSound(Horace.HitSound)
    if sound ~= nil then
        Zombie:playSoundLocal(sound)
    end
end

function HoraceSounds.OnHoraceDead(Zombie, Horace) 
    local sound = HoraceTypes.PickSound(Horace.DeathSound)
    if sound ~= nil then
        Zombie:playSoundLocal(sound)
    end
end